webdevqa.jp.net

babel-loader jsx SyntaxError:予期しないトークン

私はReact + Webpackの初心者です。

私のHello World Webアプリで奇妙なエラーを見つけました。

私はjsxからjsへの変換を手助けするためにwebpackでbabel-loaderを使っていますが、babelがjsxの構文を理解できないようです。

これが私の依存関係です。

"devDependencies": {
  "babel-core": "^6.0.14",
  "babel-loader": "^6.0.0",
  "webpack": "^1.12.2",
  "webpack-dev-server": "^1.12.1"
},
"dependencies": {
  "react": "^0.14.1"
}

これが私のwebpack.config.jsです

var path = require('path');
module.exports = {
  entry: ['webpack/hot/dev-server',path.resolve(__dirname, 'app/main.js')],
  output: {
    path: path.resolve(__dirname, 'build'),
    filename: 'bundle.js'
  },
  module: {
      loaders: [
          { test: /\.js$/, exclude: /node_modules/, loader: "babel-loader"}
      ]
  }
};

これが私のapp/main.jsです

var React = require("react");
React.render(<h1>hello world</h1>,document.getElementById("app"));

そしてこれはエラーメッセージです

ERROR in ./app/main.js
Module build failed: SyntaxError: ~/**/app/main.js: Unexpected token (2:13)
  1 | var React = require("react");
> 2 | React.render(<h1>hello world</h1>,document.getElementById("app"));
    |              ^
at Parser.pp.raise (~/**/node_modules/babylon/lib/parser/location.js:24:13)

どうもありがとう。

286
Keyu Lin

"babel-preset-react"を追加してください

npm install babel-preset-react

そしてwebpack.config.jsのbabel-loaderに "presets"オプションを追加してください。

(または、あなたの.babelrcまたはpackage.jsに追加することもできます: http://babeljs.io/docs/usage/babelrc/

これがwebpack.config.jsの例です。

{ 
    test: /\.jsx?$/,         // Match both .js and .jsx files
    exclude: /node_modules/, 
    loader: "babel", 
    query:
      {
        presets:['react']
      }
}

最近Babel 6がリリースされ、大きな変更がありました: https://babeljs.io/blog/2015/10/29/6.0.0

React 0.14を使用している場合は、ReactDOM.render()の代わりにrequire('react-dom')React.render()から)を使用する必要があります。 https://facebook.github.io/react/blog/#changelog

UPDATE 2018

Rule.queryはすでにRule.optionsを支持して推奨されていません。 Webpack 4での使い方は以下の通りです。

npm install babel-loader babel-preset-react

それから、あなたのWebPackの設定で(module.exportsオブジェクトのmodule.rules配列の中のエントリとして)

{
    test: /\.jsx?$/,
    exclude: /node_modules/,
    use: [
      {
        loader: 'babel-loader',
        options: {
          presets: ['react']
        }
      }
    ],
  }
428
Yoon

Babel 5からbabel 6に移行すると、私は同様の問題に遭遇しました。

src から lib フォルダbabel src --out-dir libをコンパイルするためにbabelを実行したところです。

私はbabel 6の設定を共有します。

次のbabelがあることを確認してください6 devDependencies installed

"babel-core": "^6.7.6",
"babel-loader": "^6.2.4",
"babel-preset-es2015": "^6.6.0",
"babel-preset-react": "^6.5.0",
"babel-preset-stage-0": "^6.5.0"

プロジェクトに .babelrc ファイルを追加します。

{
  "presets": ["es2015", "stage-0", "react"]
}
97
svnm

上の答えはまだ 何人かの人々 を暗闇の中に残しているので、完全なwebpack.config.jsはこんな感じになるでしょう:

var path = require('path');
var config = {
    entry: path.resolve(__dirname, 'app/main.js'),
    output: {
        path: path.resolve(__dirname, 'build'),
        filename: 'bundle.js'
    },
    module: {
        loaders: [{
            test: /\.jsx?$/,
            loader: 'babel',
            query:
            {
                presets:['es2015', 'react']
            }
        }]
    },

};

module.exports = config;
37
Everett

私にとっての解決策は、この内容のファイル.babelrcを作成することでした:

{
  "presets": ["react", "es2015", "stage-1"]
}
26
albanx

次のような方法が私を助けてくれました(反応熱い、babelローダーとes2015、反応プリセットを含みます):

loaders: [
      {
        test: /\.jsx?$/,
        exclude: /node_modules/,
        loaders: ['react-hot', 'babel?presets[]=es2015&presets[]=react']
      }
]
22

これは私にとって完璧に動作します

{
    test: /\.(js|jsx)$/,
    loader: 'babel-loader',
    exclude: /node_modules/,
    query: {
        presets: ['es2015','react']
    }
},
1
jose920405

あなたはここHenrik Joreteg(ampersandjs)によって作られた本当に良い定型文を見つけることができます: https://github.com/HenrikJoreteg/hjs-webpack

それであなたのwebpack.config.js

var getConfig = require('hjs-webpack')

module.exports = getConfig({
  in: 'src/index.js',
  out: 'public',
  clearBeforeBuild: true,
  https: process.argv.indexOf('--https') !== -1
})
0
Maxime Brehin

まだテストのためにjsxを追加する問題に直面しているかもしれない人のために私のためにそれを修正しました

test: /\.jsx?$/,
0
Aftab Naveed